=== debian/changelog ===
ocaml (4.02.3-9) unstable; urgency=medium

  * obey hardening LDFLAGS (Closes: #792502). Thanks to Török Edwin
    for the patch!
    - add patch 0013-Obey-ldflags.patch
  * Compute a stable name for preprocessed files (Closes: #838188).
    Thanks to Johannes Schauer for the patch!
  * CVE-2015-8869 (Closes: #824139).

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 22 Dec 2016 00:48:59 +0100

ocaml (4.02.3-8) unstable; urgency=medium

  * Default to PIC on arm, to fix failing armhf tests (Closes: #837359).
  * Use secure and canonical URIs for Vcs-* fields
  * Sync Standards-Version's value in debian/control.in

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 06 Nov 2016 11:29:41 +0100

ocaml (4.02.3-7) unstable; urgency=medium

  * d/rules: split install-stamp target into -arch and -indep, to allow
    for building with option -A (Closes: #806087).
  * drop d/ocaml-nox.links.in since it contains only links to the
    ocamlbuild.1 manpage which is no longer shipped by upstream. Thanks
    to Andreas Beckmann for the hint (Closes: #801447).
  * d/ocaml-base-nox.README.Debian: fix two spelling errors.
  * standards-version 3.9.8 (no change)

 -- Ralf Treinen <treinen@debian.org>  Fri, 15 Jul 2016 22:19:44 +0200

ocaml (4.02.3-6) unstable; urgency=medium

  * Add x32 support (Closes: #773409)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 16 Feb 2016 11:34:16 +0100

ocaml (4.02.3-5) unstable; urgency=medium

  * Fix ocamldoc with -pp (Closes: #802347)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 20 Oct 2015 11:41:11 +0200

ocaml (4.02.3-4) unstable; urgency=medium

  * Avoid multiple declarations of caml_set_oo_id in generated .c files
    - Update 0005-Avoid-multiple-declarations-in-generated-.c-files-in.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 19 Oct 2015 01:01:53 +0200

ocaml (4.02.3-3) unstable; urgency=medium

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Oct 2015 10:46:16 +0200

ocaml (4.02.3-2) experimental; urgency=medium

  * Reproducibility changes:
    - ocamlopt: add a .file directive to generated .s files
      + startup files are now deterministic (Closes: #795784)
      + native packed libraries are now deterministic (Closes: #796336)
    - set permissions of patches in ocaml-source

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Aug 2015 09:46:49 +0200

ocaml (4.02.3-1) experimental; urgency=medium

  * New upstream release
    - build and install libasmrun_shared.so (Closes: #461125)
  * Make the ocaml-source binary package reproducible (patch by Chris
    Lamb) (Closes: #779086)
  * Enable ocamldoc to build reproducible manpages (patch by Valentin
    Lorentz) (Closes: #794586)
  * Bump Standards-Version to 3.9.6

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Aug 2015 18:53:50 +0200

ocaml (4.02.1-3) experimental; urgency=medium

  * Fix asmcomp tests on sparc
  * Disable prim-bswap test (it fails on arm64)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 16 Feb 2015 11:14:06 +0100

ocaml (4.02.1-2) experimental; urgency=medium

  * Disable endianness-dependent tests
  * Add arm64 to native and natdynlink architectures
  * Merge version 4.01.0-5

 -- Stéphane Glondu <glondu@debian.org>  Wed, 19 Nov 2014 07:08:04 +0100

ocaml (4.02.1-1) experimental; urgency=medium

  * New upstream release
    - camlp4 and labltk are now distributed separately

 -- Stéphane Glondu <glondu@debian.org>  Tue, 21 Oct 2014 17:31:42 +0200

ocaml (4.01.0-5) unstable; urgency=medium

  [ Ralf Treinen ]
  * ocaml-mode: change dependency on emacs23 to emacs (closes: #754021)
  * ocaml-mode: add versionend dependency on emacs-common, add a file
    ocaml-mode.emacsen-compat (closes: #749311)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 30 Oct 2014 09:28:06 +0100

ocaml (4.01.0-4) unstable; urgency=medium

  * debian/patches:
    + Make "ocamlopt -g" more resistant to ill-formed locations
    + Fix lost locations in out-of-bounds exceptions
  * Disable the testsocket test because it tries to reach the net
    (Closes: #732951)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 17 May 2014 15:26:14 +0200
